diff -uNr src.ORIG/mclibs/herwig/code/hwiodk.F src/mclibs/herwig/code/hwiodk.F
--- src.ORIG/mclibs/herwig/code/hwiodk.F	1996-12-03 23:16:58.000000000 +0900
+++ src/mclibs/herwig/code/hwiodk.F	2005-05-31 02:34:40.000000000 +0900
@@ -12,6 +12,9 @@
 C                             0                            are set zero.
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       INTEGER IUNIT,IOPT,IME,JUNIT,I,J,K,L,IDKY,ITMP(5),IDUM
       CHARACTER*8 CDK(NMXDKS),CDKPRD(5,NMXDKS),CDUM
       JUNIT=ABS(IUNIT)
@@ -26,7 +29,12 @@
           DO 10 J=1,NMODES(I)
           WRITE(JUNIT,110) IDPDG(I),BRFRAC(K),NME(K),
      &                    (IDPDG(IDKPRD(L,K)),L=1,5)
+#if !defined(CERNLIB_GFORTRAN)
   10      K=LNEXT(K)
+#else
+             K=LNEXT(K)
+  10      continue
+#endif
   20      CONTINUE
         ELSEIF (IOPT.EQ.2) THEN
           DO 40 I=1,NRES
@@ -34,7 +42,12 @@
           K=LSTRT(I)
           DO 30 J=1,NMODES(I)
           WRITE(JUNIT,120) I,BRFRAC(K),NME(K),(IDKPRD(L,K),L=1,5)
+#if !defined(CERNLIB_GFORTRAN)
   30      K=LNEXT(K)
+#else
+             K=LNEXT(K)
+  30      continue
+#endif
   40      CONTINUE
         ELSEIF (IOPT.EQ.3) THEN
           DO 60 I=1,NRES
@@ -43,34 +56,66 @@
           DO 50 J=1,NMODES(I)
           WRITE(JUNIT,130) RNAME(I),BRFRAC(K),NME(K),
      &                    (RNAME(IDKPRD(L,K)),L=1,5)
+#if !defined(CERNLIB_GFORTRAN)
   50      K=LNEXT(K)
+#else
+             K=LNEXT(K)
+  50      continue
+#endif
   60      CONTINUE
         ENDIF
       ELSEIF (IUNIT.LT.0) THEN
 C Read in the decay table and convert to HERWIG numeric format
         READ(JUNIT,100) NDKYS
+#if !defined(CERNLIB_GFORTRAN)
         IF (NDKYS.GT.NMXDKS) CALL HWWARN('HWIODK',100,*999)
+#else
+        if (NDKYS.GT.NMXDKS) then
+          call hwwarn('HWIODK',100,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
         IF (IOPT.EQ.1) THEN
           DO 70 I=1,NDKYS
           READ(JUNIT,110) IDKY,BRFRAC(I),NME(I),ITMP
           IF (IME.EQ.0.AND.NME(I).GE.100) NME(I)=0
           CALL HWUIDT(1,IDKY,IDK(I),CDUM)
           DO 70 J=1,5
+#if !defined(CERNLIB_GFORTRAN)
   70      CALL HWUIDT(1,ITMP(J),IDKPRD(J,I),CDUM)
+#else
+             CALL HWUIDT(1,ITMP(J),IDKPRD(J,I),CDUM)
+  70      continue
+#endif
         ELSEIF (IOPT.EQ.2) THEN
           DO 80 I=1,NDKYS
           READ(JUNIT,120) IDK(I),BRFRAC(I),NME(I),(IDKPRD(J,I),J=1,5)
           IF (IDK(I).LT.0.OR.IDK(I).GT.NRES) IDK(I)=20
+#if !defined(CERNLIB_GFORTRAN)
   80      IF (IME.EQ.0.AND.NME(I).GE.100) NME(I)=0
+#else
+             IF (IME.EQ.0.AND.NME(I).GE.100) NME(I)=0
+  80      continue
+#endif
         ELSEIF (IOPT.EQ.3) THEN
           DO 90 I=1,NDKYS
           READ(JUNIT,130) CDK(I),BRFRAC(I),NME(I),(CDKPRD(J,I),J=1,5)
           IF (IME.EQ.0.AND.NME(I).GE.100) NME(I)=0
           CALL HWUIDT(3,IDUM,IDK(I),CDK(I))
           DO 90 J=1,5
+#if !defined(CERNLIB_GFORTRAN)
   90      CALL HWUIDT(3,IDUM,IDKPRD(J,I),CDKPRD(J,I))
+#else
+             CALL HWUIDT(3,IDUM,IDKPRD(J,I),CDKPRD(J,I))
+  90      continue
+#endif
         ELSE
+#if !defined(CERNLIB_GFORTRAN)
           CALL HWWARN('HWIODK',101,*999)
+#else
+          call hwwarn('HWIODK',101,iret)
+        if (iret .eq. 1) go to 999
+#endif
         ENDIF
       ENDIF
       CLOSE(UNIT=JUNIT)
diff -uNr src.ORIG/mclibs/herwig/code/hwmevt.F src/mclibs/herwig/code/hwmevt.F
--- src.ORIG/mclibs/herwig/code/hwmevt.F	1996-12-03 23:16:58.000000000 +0900
+++ src/mclibs/herwig/code/hwmevt.F	2005-05-31 02:34:40.000000000 +0900
@@ -9,6 +9,9 @@
 C     SUPPRESSED BY ADDING 10000 TO IPROC
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWREXP,ENFAC,TECM,SECM,SUMM,EMCL,BMP(5),BMR(3,3)
       INTEGER HWRINT,NETC,IBT,IDBT,ID1,ID2,ID3,KHEP,LHEP,NTRY,ICMS,
      & NPPBAR,NCL,MCHT,JCL,JD1,JD2,JD3,ICH,MODC,NCHT,INHEP(2),
@@ -45,7 +48,12 @@
           INID(1,IBT)=HWRINT(1,2)
           INID(2,IBT)=HWRINT(7,8)
         ELSE
+#if !defined(CERNLIB_GFORTRAN)
           CALL HWWARN('HWMEVT',100,*999)
+#else
+          call hwwarn('HWMEVT',100,iret)
+        if (iret .eq. 1) go to 999
+#endif
         ENDIF
         NETC=NETC+ICHRG(IDBT)
      &    -(ICHRG(INID(1,IBT))+ICHRG(INID(2,IBT)))/3
@@ -69,7 +77,12 @@
         JBT=IBT
         IF (JDAHEP(1,IBT).NE.0) JBT=JDAHEP(1,IBT)
         CALL HWVEQU(5,PHEP(1,JBT),PHEP(1,NHEP))
+#if !defined(CERNLIB_GFORTRAN)
    12   INHEP(IBT)=NHEP
+#else
+           INHEP(IBT)=NHEP
+   12   continue
+#endif
       ELSE
 C---FIND BEAM AND TARGET CLUSTERS
         DO 20 IBT=1,2
@@ -88,7 +101,14 @@
 C---TEST FOR BOTH FOUND
         IF (INHEP(1).EQ.0) JCL=INHEP(2)
         IF (INHEP(2).EQ.0) JCL=INHEP(1)
+#if !defined(CERNLIB_GFORTRAN)
         IF (JCL.EQ.0) CALL HWWARN('HWMEVT',101,*999)
+#else
+        if (JCL.EQ.0) then
+          call hwwarn('HWMEVT',101,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
         IF (JCL.GT.0) THEN
           ISTHEP(JCL)=163
           CALL HWCFOR
@@ -103,7 +123,14 @@
 C---FIND SOFT CM MOMENTUM AND MULTIPLICITY
       NTRY=0
       NHEP=NHEP+1
+#if !defined(CERNLIB_GFORTRAN)
       IF (NHEP.GT.NMXHEP) CALL HWWARN('HWMEVT',102,*999)
+#else
+      if (NHEP.GT.NMXHEP) then
+          call hwwarn('HWMEVT',102,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
       ICMS=NHEP
       IDHW(NHEP)=16
       IDHEP(NHEP)=0
@@ -127,7 +154,14 @@
 C---CREATE CLUSTERS
    35 NCL=NCL+1
       NHEP=NHEP+1
+#if !defined(CERNLIB_GFORTRAN)
       IF (NHEP.GT.NMXHEP) CALL HWWARN('HWMEVT',103,*999)
+#else
+      if (NHEP.GT.NMXHEP) then
+          call hwwarn('HWMEVT',103,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
       JCL=NHEP
       IDHW(JCL)=19
       IDHEP(JCL)=91
diff -uNr src.ORIG/mclibs/herwig/code/hwmlps.F src/mclibs/herwig/code/hwmlps.F
--- src.ORIG/mclibs/herwig/code/hwmlps.F	1996-12-03 23:16:58.000000000 +0900
+++ src/mclibs/herwig/code/hwmlps.F	2005-05-31 02:34:40.000000000 +0900
@@ -8,6 +8,9 @@
 C     RETURNS NCL=0 IF UNSUCCESSFUL
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWREXT,HWRUNG,HWUSQR,TECM,ESS,ALOGS,EPS,SUMX,
      & SUMY,PT,PX,PY,PT2,SUMPT2,SUMTM,XIMIN,XIMAX,YY,SUM1,SUM2,SUM3,
      & SUM4,EX,FY,DD,DYY,ZZ,E1,TM,SLOP(11),XI(NMXPAR)
@@ -20,7 +23,12 @@
       DATA SLOP/5.2,5.2,5.2,3.0,5.2,5.2,5.2,5.2,5.2,5.2,3.0/
 C                -   d   u   s   uu  ud  dd  us  ds  ss  c
       IF (NCL.GT.NMXPAR) THEN
+#if !defined(CERNLIB_GFORTRAN)
         CALL HWWARN('HWMLPS',1,*999)
+#else
+        call hwwarn('HWMLPS',1,iret)
+        if (iret .eq. 1) go to 999
+#endif
         NCL=NMXPAR
       ENDIF
       ESS=TECM**2
@@ -42,7 +50,12 @@
       PPAR(1,I)=PX
       PPAR(2,I)=PY
       SUMX=SUMX+PPAR(1,I)
+#if !defined(CERNLIB_GFORTRAN)
   12  SUMY=SUMY+PPAR(2,I)
+#else
+         SUMY=SUMY+PPAR(2,I)
+  12  continue
+#endif
       SUMX=SUMX/NCL
       SUMY=SUMY/NCL
       SUMPT2=0.
@@ -54,7 +67,12 @@
       SUMPT2=SUMPT2+PT2
 C---STORE TRANSVERSE MASS IN PPAR(3,I) TEMPORARILY
       PPAR(3,I)=SQRT(PT2+PPAR(5,I)**2)
+#if !defined(CERNLIB_GFORTRAN)
   13  SUMTM=SUMTM+PPAR(3,I)
+#else
+         SUMTM=SUMTM+PPAR(3,I)
+  13  continue
+#endif
       IF (SUMTM.GT.TECM) GOTO 11
       DO 14 I=1,NCL
 C---Form of "reduced rapidity" distribution
@@ -81,17 +99,39 @@
       SUM1=SUM1+(TM*EX)
       SUM2=SUM2+(TM/EX)
       SUM3=SUM3+(TM*EX)*XI(I)
+#if !defined(CERNLIB_GFORTRAN)
   19  SUM4=SUM4+(TM/EX)*XI(I)
+#else
+         SUM4=SUM4+(TM/EX)*XI(I)
+  19  continue
+#endif
       FY=ALOGS-LOG(SUM1*SUM2)
       DD=(SUM3*SUM2-SUM1*SUM4)/(SUM1*SUM2)
       DYY=FY/DD
       IF(ABS(DYY/YY).LT.EPS) GOTO 20
+#if !defined(CERNLIB_GFORTRAN)
   18  YY=YY+DYY
 C---Y ITERATIONS EXCEEDED - TRY AGAIN
+#else
+         YY=YY+DYY
+  18  continue
+#endif
       IF (NTRY.LT.10) GOTO 11
       EPS=10.*EPS
+#if !defined(CERNLIB_GFORTRAN)
       IF (EPS.GT.1.) CALL HWWARN('HWMLPS',100,*999)
+#else
+      if (EPS.GT.1.) then
+          call hwwarn('HWMLPS',100,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
+#if !defined(CERNLIB_GFORTRAN)
       CALL HWWARN('HWMLPS',50,*11)
+#else
+      call hwwarn('HWMLPS',50,iret)
+        if (iret .eq. 1) go to 11
+#endif
    20 YY=YY+DYY
       ZZ=LOG(TECM/SUM1)
       DO 22 I=1,NCL
diff -uNr src.ORIG/mclibs/herwig/code/hwmodk.F src/mclibs/herwig/code/hwmodk.F
--- src.ORIG/mclibs/herwig/code/hwmodk.F	1996-12-03 23:16:58.000000000 +0900
+++ src/mclibs/herwig/code/hwmodk.F	2005-05-31 02:34:40.000000000 +0900
@@ -14,6 +14,9 @@
 C     scaled by (1.-BRTMP)/(1.-BR_OLD)
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWUPCM,BRTMP,SCALE,EPS
       INTEGER IDKTMP,IMETMP,IATMP,IBTMP,ICTMP,IDTMP,IETMP,IDKY,ITMP(5),
      & L,I,J,K,JPREV
@@ -36,12 +39,24 @@
 C If internal pointers not yet set up simply store decay
       IF (.NOT.DKPSET) THEN
         NDKYS=NDKYS+1
+#if !defined(CERNLIB_GFORTRAN)
         IF (NDKYS.GT.NMXDKS) CALL HWWARN('HWMODK',100,*999)
+#else
+        if (NDKYS.GT.NMXDKS) then
+          call hwwarn('HWMODK',100,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
         IDK(NDKYS)=IDKY
         BRFRAC(NDKYS)=BRTMP
         NME(NDKYS)=IMETMP
         DO 20 I=1,5
+#if !defined(CERNLIB_GFORTRAN)
   20    IDKPRD(I,NDKYS)=ITMP(I)
+#else
+           IDKPRD(I,NDKYS)=ITMP(I)
+  20    continue
+#endif
       ELSE
         IF (NMODES(IDKY).GT.0) THEN
 C First search to see if mode pre-exists
@@ -55,13 +70,23 @@
      &              ITMP(3).EQ.IDKPRD(3,L).AND.
      &              ITMP(4).EQ.IDKPRD(4,L).AND.
      &              ITMP(5).EQ.IDKPRD(5,L)) GOTO 90
+#if !defined(CERNLIB_GFORTRAN)
   30        L=LNEXT(L)
+#else
+               L=LNEXT(L)
+  30        continue
+#endif
           ELSE
 C Allow for different order in matching
             L=LSTRT(IDKY)
             DO 70 I=1,NMODES(IDKY)
             DO 40 J=1,5
+#if !defined(CERNLIB_GFORTRAN)
   40        MATCH(J)=.FALSE.
+#else
+               MATCH(J)=.FALSE.
+  40        continue
+#endif
             DO 60 J=1,5
             DO 50 K=1,5
             IF (.NOT.MATCH(K).AND.ITMP(K).EQ.IDKPRD(J,L)) THEN
@@ -72,15 +97,32 @@
   60        CONTINUE
             IF (MATCH(1).AND.MATCH(2).AND.MATCH(3).AND.
      &          MATCH(4).AND.MATCH(5)) GOTO 90
+#if !defined(CERNLIB_GFORTRAN)
   70        L=LNEXT(L)
+#else
+               L=LNEXT(L)
+  70        continue
+#endif
           ENDIF
         ENDIF
 C A new mode put decay products in table
         NDKYS=NDKYS+1
+#if !defined(CERNLIB_GFORTRAN)
         IF (NDKYS.GT.NMXDKS) CALL HWWARN('HWMODK',100,*999)
+#else
+        if (NDKYS.GT.NMXDKS) then
+          call hwwarn('HWMODK',100,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
         DO 80 I=1,5
+#if !defined(CERNLIB_GFORTRAN)
   80    IDKPRD(I,NDKYS)=ITMP(I)
 C If decay consistent set up new pointers
+#else
+           IDKPRD(I,NDKYS)=ITMP(I)
+  80    continue
+#endif
         CALL HWDCHK(IDKY,NDKYS,*980)
         IF (NMODES(IDKY).EQ.0) THEN
           LSTRT(IDKY)=NDKYS
@@ -121,7 +163,12 @@
               DO 100 I=2,NMODES(IDKY)
               J=LNEXT(J)
               IF (J.EQ.L) LNEXT(JPREV)=LNEXT(J)
+#if !defined(CERNLIB_GFORTRAN)
   100         JPREV=(J)
+#else
+                JPREV=(J)
+  100         continue
+#endif
             ENDIF
           ENDIF
           NMODES(IDKY)=NMODES(IDKY)-1
@@ -138,7 +185,12 @@
           J=LSTRT(IDKY)
           DO 110 I=1,NMODES(IDKY)
           IF (J.NE.L) BRFRAC(J)=SCALE*BRFRAC(J)
+#if !defined(CERNLIB_GFORTRAN)
   110     J=LNEXT(J)
+#else
+            J=LNEXT(J)
+  110     continue
+#endif
         ENDIF
       ENDIF
       GOTO 999
diff -uNr src.ORIG/mclibs/herwig/code/hwmult.F src/mclibs/herwig/code/hwmult.F
--- src.ORIG/mclibs/herwig/code/hwmult.F	1996-12-03 23:16:58.000000000 +0900
+++ src/mclibs/herwig/code/hwmult.F	2005-05-31 02:34:40.000000000 +0900
@@ -36,7 +36,12 @@
             CUM(1)=1
          ELSE
             DO 12 I=1,IMAX
+#if !defined(CERNLIB_GFORTRAN)
   12        CUM(I)=CUM(I)/SUM
+#else
+               CUM(I)=CUM(I)/SUM
+  12        continue
+#endif
          ENDIF
       ENDIF
 C --- Select NCHT
@@ -46,5 +51,10 @@
       NCHT=2*I
       RETURN
   20  CONTINUE
+#if !defined(CERNLIB_GFORTRAN)
       CALL HWWARN('HWMULT',100,*999)
+#else
+      call hwwarn('HWMULT',100,iret)
+        if (iret .eq. 1) go to 999
+#endif
   999 END
diff -uNr src.ORIG/mclibs/herwig/code/hwmwgt.F src/mclibs/herwig/code/hwmwgt.F
--- src.ORIG/mclibs/herwig/code/hwmwgt.F	1996-12-03 23:16:58.000000000 +0900
+++ src/mclibs/herwig/code/hwmwgt.F	2005-05-31 02:34:21.000000000 +0900
@@ -7,6 +7,9 @@
 C COMPUTES WEIGHT FOR MINIMUM-BIAS EVENT
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION S,X,Y
       INTEGER IDB,IDT,IDBT
       IF (IERROR.NE.0) RETURN
@@ -51,7 +54,12 @@
         Y=3.0E-4
       ELSE
         PRINT *,' IDBT=',IDBT
+#if !defined(CERNLIB_GFORTRAN)
         CALL HWWARN('HWMWGT',100,*999)
+#else
+        call hwwarn('HWMWGT',100,iret)
+        if (iret .eq. 1) go to 999
+#endif
       ENDIF
       S=PHEP(5,3)**2
 C---EVWGT IS NON-DIFFRACTIVE CROSS SECTION IN NANOBARNS
diff -uNr src.ORIG/mclibs/herwig/code/hwrext.F src/mclibs/herwig/code/hwrext.F
--- src.ORIG/mclibs/herwig/code/hwrext.F	1996-12-03 23:16:58.000000000 +0900
+++ src/mclibs/herwig/code/hwrext.F	2005-05-31 02:34:22.000000000 +0900
@@ -22,6 +22,11 @@
       IF(AM.LT.AM0) AM=AM0+.001
       IF(ABS(DAM).LT..001) GOTO 2
    1  CONTINUE
+#if !defined(CERNLIB_GFORTRAN)
       CALL HWWARN('HWREXT',1,*2)
+#else
+      call hwwarn('HWREXT',1,iret)
+        if (iret .eq. 1) go to 2
+#endif
    2  HWREXT=AM
       END
diff -uNr src.ORIG/mclibs/herwig/code/hwrgen.F src/mclibs/herwig/code/hwrgen.F
--- src.ORIG/mclibs/herwig/code/hwrgen.F	1996-12-03 23:16:58.000000000 +0900
+++ src/mclibs/herwig/code/hwrgen.F	2005-05-31 02:45:23.000000000 +0900
@@ -10,6 +10,9 @@
       IMPLICIT NONE
       DOUBLE PRECISION HWRGEN,HWRSET,HWRGET
       INTEGER I,ISEED(2),K,IZ,JSEED(2)
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       SAVE ISEED
       DATA ISEED/12345,67890/
       K=ISEED(1)/53668
@@ -26,7 +29,12 @@
 C-----------------------------------------------------------------------
       ENTRY HWRSET(JSEED)
 C-----------------------------------------------------------------------
+#if !defined(CERNLIB_GFORTRAN)
       IF (JSEED(1).EQ.0.OR.JSEED(2).EQ.0) CALL HWWARN('HWRSET',99,*999)
+#else
+      IF (JSEED(1).EQ.0.OR.JSEED(2).EQ.0) call hwwarn('HWRSET',99,iret)
+        if (iret .eq. 1) go to 999
+#endif
       ISEED(1)=JSEED(1)
       ISEED(2)=JSEED(2)
  999  RETURN
diff -uNr src.ORIG/mclibs/herwig/code/hwrpip.F src/mclibs/herwig/code/hwrpip.F
--- src.ORIG/mclibs/herwig/code/hwrpip.F	1996-12-03 23:16:58.000000000 +0900
+++ src/mclibs/herwig/code/hwrpip.F	2005-05-31 02:34:41.000000000 +0900
@@ -12,6 +12,11 @@
       EXTERNAL HWRGAU
       DATA VIP,VIPWID/3*0.0,.25,.015,1.8/
       DO 10 I=1,3
+#if !defined(CERNLIB_GFORTRAN)
   10  VTXPIP(I)=HWRGAU(I,VIP(I),VIPWID(I))
+#else
+         VTXPIP(I)=HWRGAU(I,VIP(I),VIPWID(I))
+  10  continue
+#endif
       VTXPIP(4)=0.
       END
diff -uNr src.ORIG/mclibs/herwig/code/hwrpow.F src/mclibs/herwig/code/hwrpow.F
--- src.ORIG/mclibs/herwig/code/hwrpow.F	1996-12-03 23:16:58.000000000 +0900
+++ src/mclibs/herwig/code/hwrpow.F	2005-05-31 02:34:22.000000000 +0900
@@ -15,7 +15,14 @@
       COMMON/HWRPIN/XMIN,XMAX,XPOW,FIRST
       IF (FIRST) THEN
         P=XPOW+1.
+#if !defined(CERNLIB_GFORTRAN)
         IF (P.EQ.0.) CALL HWWARN('HWRPOW',500,*999)
+#else
+        if (P.EQ.0.) then
+          call hwwarn('HWRPOW',500,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
         Q=1./P
         A=XMIN**P
         B=XMAX**P-A
diff -uNr src.ORIG/mclibs/herwig/code/hwsbrn.F src/mclibs/herwig/code/hwsbrn.F
--- src.ORIG/mclibs/herwig/code/hwsbrn.F	1996-12-03 23:16:59.000000000 +0900
+++ src/mclibs/herwig/code/hwsbrn.F	2005-05-31 02:34:22.000000000 +0900
@@ -7,6 +7,9 @@
 C     DOES BRANCHING OF SPACELIKE PARTON KPAR
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWBVMC,HWRGEN,HWRUNI,HWSTAB,HWUALF,HWUTAB,HWSGQQ,
      & HWSSUD,XLAST,QNOW,QLST,QP,QMIN,QLAM,QSAV,SMAX,SLST,SNOW,RN,SUDA,
      & SUDB,ZZ,ENOW,XI,PMOM,DIST(13),DMIN,X1,X2,REJFAC,OTHXI,OTHZ,QTMP,
@@ -36,7 +39,14 @@
         VALPAR=HWSVAL(ID)
         QP=HWBVMC(ID)
         XLAST=XFACT*PPAR(4,KPAR)
+#if !defined(CERNLIB_GFORTRAN)
         IF (XLAST.GE.1.) CALL HWWARN('HWSBRN',107,*999)
+#else
+        if (XLAST.GE.1.) then
+          call hwwarn('HWSBRN',107,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
 C--SET UP Q BOUNDARY
         IF (VALPAR) THEN
           QMIN=QG/(1.-XLAST)
@@ -66,7 +76,14 @@
         IF (QLST.GT.QMIN.AND..NOT.NOSPAC.OR..NOT.VALPAR) THEN
           IF (QLST.LE.QMIN) THEN
 C--CHECK PHASE SPACE FOR FORCED SPLITTING OF NON-VALENCE PARTON
+#if !defined(CERNLIB_GFORTRAN)
             IF (QLST.LT.QSAV) CALL HWWARN('HWSBRN',ISLENT*105,*999)
+#else
+            if (QLST.LT.QSAV) then
+          call hwwarn('HWSBRN',ISLENT*105,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
             FORCE=.TRUE.
             QNOW=(QLST/QSAV)**HWRGEN(0)*QSAV
           ELSE
@@ -104,7 +121,14 @@
               NDEL=32
               NA=N1
   130         NB=NA+NDEL
+#if !defined(CERNLIB_GFORTRAN)
               IF (NB.GT.NQEV) CALL HWWARN('HWSBRN',103,*999)
+#else
+              if (NB.GT.NQEV) then
+          call hwwarn('HWSBRN',103,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
               CALL HWSFUN(XLAST,QEV(NB,IS),IDHAD,NSTRU,DIST,JNHAD)
               IF (ID.EQ.13) DIST(ID)=DIST(ID)*HWSGQQ(QEV(NB,IS))
               IF (DIST(ID).LT.DMIN) DIST(ID)=DMIN
@@ -116,7 +140,14 @@
               ELSEIF (NA.NE.N1) THEN
                 IF (SUDB.LT.SNOW) THEN
                   NDEL=NDEL/2
+#if !defined(CERNLIB_GFORTRAN)
                   IF (NDEL.EQ.0) CALL HWWARN('HWSBRN',100,*999)
+#else
+                  if (NDEL.EQ.0) then
+          call hwwarn('HWSBRN',100,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
                   GOTO 130
                 ENDIF
                 N1=NB
@@ -146,23 +177,47 @@
           CALL HWSFBR(XLAST,QNOW,FORCE,ID,1,ID1,ID2,IW1,IW2,ZZ)
           IF (ID1.LT.0) THEN
 C--NO PHASE SPACE FOR BRANCHING
+#if !defined(CERNLIB_GFORTRAN)
             CALL HWWARN('HWSBRN',ISLENT*101,*999)
+#else
+            call hwwarn('HWSBRN',ISLENT*101,iret)
+        if (iret .eq. 1) go to 999
+#endif
           ELSEIF (ID1.EQ.0) THEN
 C--BRANCHING REJECTED: REDUCE Q AND REPEAT
             IF (NTRY.GT.NBTRY.OR.IERROR.NE.0)
+#if !defined(CERNLIB_GFORTRAN)
      $           CALL HWWARN('HWSBRN',102,*999)
+#else
+     $           call hwwarn('HWSBRN',102,iret)
+        if (iret .eq. 1) go to 999
+#endif
             QLST=QNOW
             QNOW=-1.
             GOTO 125
           ELSEIF (ID1.EQ.59) THEN
 C--ANOMALOUS PHOTON SPLITTING: ADD PT TO INTRINSIC PT AND STOP BRANCHING
+#if !defined(CERNLIB_GFORTRAN)
             IF (IDHAD.NE.59) CALL HWWARN('HWSBRN',109,*999)
+#else
+            if (IDHAD.NE.59) then
+          call hwwarn('HWSBRN',109,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
             ENOW=PPAR(4,KPAR)/XLAST
             XI=(QNOW/ENOW)**2
             QLAM=QNOW*(1.-XLAST)
             IF ((2.-XI)*QLAM**2.GT.EMSCA**2) THEN
 C--BRANCHING REJECTED: REDUCE Q AND REPEAT
+#if !defined(CERNLIB_GFORTRAN)
               IF (NTRY.GT.NBTRY) CALL HWWARN('HWSBRN',110,*999)
+#else
+              if (NTRY.GT.NBTRY) then
+          call hwwarn('HWSBRN',110,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
               QLST=QNOW
               QNOW=-1.
               GOTO 125
@@ -177,7 +232,14 @@
             GOTO 125
           ELSEIF (FORCE.AND..NOT.HWSVAL(ID1).AND.ID1.NE.13) THEN
 C--FORCED BRANCHING PRODUCED A NON-VALENCE PARTON: TRY AGAIN
+#if !defined(CERNLIB_GFORTRAN)
             IF (NTRY.GT.NBTRY) CALL HWWARN('HWSBRN',108,*999)
+#else
+            if (NTRY.GT.NBTRY) then
+          call hwwarn('HWSBRN',108,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
             QLST=QNOW
             QNOW=-1.
             GOTO 125
@@ -192,7 +254,14 @@
           IF (SUDORD.EQ.1.AND.HWUALF(2,QLAM).LT.HWRGEN(0) .OR.
      &        (2.-XI)*QLAM**2.GT.EMSCA**2.AND..NOT.FORCE) THEN
 C--BRANCHING REJECTED: REDUCE Q AND REPEAT
+#if !defined(CERNLIB_GFORTRAN)
               IF (NTRY.GT.NBTRY) CALL HWWARN('HWSBRN',104,*999)
+#else
+              if (NTRY.GT.NBTRY) then
+          call hwwarn('HWSBRN',104,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
               QLST=QNOW
               QNOW=-1.
               GOTO 125
diff -uNr src.ORIG/mclibs/herwig/code/hwsfbr.F src/mclibs/herwig/code/hwsfbr.F
--- src.ORIG/mclibs/herwig/code/hwsfbr.F	1996-12-03 23:16:59.000000000 +0900
+++ src/mclibs/herwig/code/hwsfbr.F	2005-05-31 02:34:41.000000000 +0900
@@ -72,21 +72,41 @@
       IF (ID.NE.13) THEN
 C---SPLITTING INTO QUARK
         DO 10 IP=1,ID-1
+#if !defined(CERNLIB_GFORTRAN)
    10   PROB(IP,IZ)=PSUM
+#else
+           PROB(IP,IZ)=PSUM
+   10   continue
+#endif
         IF (NONF) PSUM=PSUM+DIST(ID)*AZ*CFFAC*(1.+ZZ*ZZ)*WR
         DO 20 IP=ID,12
+#if !defined(CERNLIB_GFORTRAN)
    20   PROB(IP,IZ)=PSUM
+#else
+           PROB(IP,IZ)=PSUM
+   20   continue
+#endif
         PSUM=PSUM+DIST(13)*AZ*0.5*(ZZ*ZZ+WZ*WZ)
         PROB(13,IZ)=PSUM
       ELSE
 C---SPLITTING INTO GLUON
         DO 30 IP=1,12
         PSUM=PSUM+DIST(IP)*AZ*CFFAC*(1.+WZ*WZ)*ZR
+#if !defined(CERNLIB_GFORTRAN)
    30   PROB(IP,IZ)=PSUM
+#else
+           PROB(IP,IZ)=PSUM
+   30   continue
+#endif
         IF (NONF) PSUM=PSUM+DIST(13)*AZ*2.*CAFAC*(WZ*ZR+ZZ*WR+WZ*ZZ)
         PROB(13,IZ)=PSUM
       ENDIF
+#if !defined(CERNLIB_GFORTRAN)
    40 YY=YY+DELY
+#else
+         YY=YY+DELY
+   40 continue
+#endif
    50 PHOTPR=IDHAD.EQ.59.AND.ID.NE.13
       IF (PHOTPR) THEN
 C---ALLOW ANOMALOUS PHOTON SPLITTING
diff -uNr src.ORIG/mclibs/herwig/code/hwsfun.F src/mclibs/herwig/code/hwsfun.F
--- src.ORIG/mclibs/herwig/code/hwsfun.F	1996-12-03 23:16:59.000000000 +0900
+++ src/mclibs/herwig/code/hwsfun.F	2005-05-31 02:47:16.000000000 +0900
@@ -55,6 +55,9 @@
 C   CERN_ROOT:[DOC]PDFLIB.TXT ON VXCERN
 C-----------------------------------------------------------------------
       INCLUDE 'HERWIG59.INC'
+#if defined(CERNLIB_GFORTRAN)
+      integer iret
+#endif
       DOUBLE PRECISION HWSGAM,X,SCALE,XOLD,QOLD,XMWN,QSCA,SS,SMIN,S,T,
      & TMIN,TMAX,VX,AA,VT,WT,UPV,DNV,SEA,STR,CHM,BTM,TOP,GLU,WX,XQSUM,
      & DMIN,TPMIN,TPMAX,DIST(13),G(2),Q0(5),QL(5),F(5),A(6,5),
@@ -354,9 +357,23 @@
       DATA TBMIN,TTMIN/8.1905,7.4474,11.5528,10.8097/
       DATA XOLD,QOLD,IOLD,NOLD/-1.,0.,0,0/
       DATA DMIN,Q0,QL/0.,2*2.,2*2.236,2.,.2,.4,.2,.29,.177/
+#if !defined(CERNLIB_GFORTRAN)
       IF (X.LE.0.) CALL HWWARN('HWSFUN',100,*999)
+#else
+      if (X.LE.0.) then
+          call hwwarn('HWSFUN',100,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
       XMWN=ONE-X
+#if !defined(CERNLIB_GFORTRAN)
       IF (XMWN.LE.0.) CALL HWWARN('HWSFUN',101,*999)
+#else
+      if (XMWN.LE.0.) then
+          call hwwarn('HWSFUN',101,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
 C---FREEZE THE SCALE IF REQUIRED
       SCALEF=SCALE
       IF (ISPAC.GT.0) SCALEF=MAX(SCALEF,QSPAC)
@@ -375,8 +392,22 @@
 C---FIX TO CALL SCHULER-SJOSTRAND CODE
           IF (AUTPDF(IBEAM).EQ.'SaSph') THEN
             XSP=X
+#if !defined(CERNLIB_GFORTRAN)
             IF (XSP.LE.0.) CALL HWWARN('HWSFUN',102,*999)
+#else
+            if (XSP.LE.0.) then
+          call hwwarn('HWSFUN',102,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
+#if !defined(CERNLIB_GFORTRAN)
             IF (1.-XSP.LE.0.) CALL HWWARN('HWSFUN',103,*999)
+#else
+            if (1.-XSP.LE.0.) then
+          call hwwarn('HWSFUN',103,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
             Q2=QSCA**2
             ISET=MOD(MODPDF(IBEAM),10)
             IOP1=MOD(MODPDF(IBEAM)/10,2)
@@ -392,7 +423,12 @@
             CALL SASGAM(ISET,XSP,Q2,P2,IP2,F2GM,XPGA)
             IF (IOP1.EQ.1 .AND. ISTAT.LT.10) THEN
               DO 5 I=-6,6
+#if !defined(CERNLIB_GFORTRAN)
  5            XPGA(I)=XPVMD(I)+XPANL(I)+XPBEH(I)+XPDIR(I)
+#else
+                  XPGA(I)=XPVMD(I)+XPANL(I)+XPBEH(I)+XPDIR(I)
+ 5            continue
+#endif
             ENDIF
             UPV=XPGA(2)
             DNV=XPGA(1)
@@ -413,8 +449,22 @@
           DIST(8)=USEA
         ELSE
           XSP=X
+#if !defined(CERNLIB_GFORTRAN)
           IF (XSP.LE.0.) CALL HWWARN('HWSFUN',102,*999)
+#else
+          if (XSP.LE.0.) then
+          call hwwarn('HWSFUN',102,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
+#if !defined(CERNLIB_GFORTRAN)
           IF (1.-XSP.LE.0.) CALL HWWARN('HWSFUN',103,*999)
+#else
+          if (1.-XSP.LE.0.) then
+          call hwwarn('HWSFUN',103,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
           Q2=SCALEF**2
           W2=Q2*(1-X)/X
           EMC2=4*RMASS(4)**2
@@ -463,7 +513,12 @@
             TOP=TOP*FAC
             GLU=GLU*FAC**2
           ELSE
+#if !defined(CERNLIB_GFORTRAN)
             CALL HWWARN('HWSFUN',1,*999)
+#else
+            call hwwarn('HWSFUN',1,iret)
+        if (iret .eq. 1) go to 999
+#endif
           ENDIF
         ENDIF
         GOTO 900
@@ -478,7 +533,14 @@
         IF (QSCA.LT.Q0(NSET)) QSCA=Q0(NSET)
         IF (QSCA.NE.QOLD.OR.IDHAD.NE.IOLD.OR.NSET.NE.NOLD) THEN
 C---INITIALIZE
+#if !defined(CERNLIB_GFORTRAN)
           IF (NSET.LT.1.OR.NSET.GT.5) CALL HWWARN('HWSFUN',400,*999)
+#else
+          if (NSET.LT.1.OR.NSET.GT.5) then
+          call hwwarn('HWSFUN',400,iret)
+          if (iret .eq. 1) go to 999
+        endif
+#endif
           QOLD=QSCA
           IOLD=IDHAD
           NOLD=NSET
@@ -496,7 +558,12 @@
               IP=NSET
               DO 10 I=1,5
               DO 10 J=1,6
+#if !defined(CERNLIB_GFORTRAN)
    10         A(J,I)=B(1,J,I,IP)+S*(B(2,J,I,IP)+S*B(3,J,I,IP))
+#else
+                 A(J,I)=B(1,J,I,IP)+S*(B(2,J,I,IP)+S*B(3,J,I,IP))
+   10         continue
+#endif
               DO 20 K=1,2
               AA=ONE+A(2,K)+A(3,K)
    20         G(K)=HWSGAM(AA)/((ONE+A(2,K)*A(4,K)/AA)*HWSGAM(A(2,K))
@@ -504,7 +571,12 @@
             ELSEIF (NSET.EQ.5) THEN
               DO 21 I=1,5
               DO 21 J=1,6
+#if !defined(CERNLIB_GFORTRAN)
    21         A(J,I)=BB(1,J,I)+S*(BB(2,J,I)+S*(BB(3,J,I)+S*BB(4,J,I)))
+#else
+              A(J,I)=BB(1,J,I)+S*(BB(2,J,I)+S*(BB(3,J,I)+S*BB(4,J,I)))
+   21         continue
+#endif
               DO 22 K=1,2
               AA=ONE+A(2,K)+A(3,K)
    22         G(K)=HWSGAM(AA)/((ONE+A(2,K)/AA*(A(4,K)+
@@ -526,7 +598,12 @@
               IP=NSET+2
               DO 30 I=1,5
               DO 30 J=1,6
+#if !defined(CERNLIB_GFORTRAN)
    30         A(J,I)=B(1,J,I,IP)+S*(B(2,J,I,IP)+S*B(3,J,I,IP))
+#else
+                 A(J,I)=B(1,J,I,IP)+S*(B(2,J,I,IP)+S*B(3,J,I,IP))
+   30         continue
+#endif
               AA=ONE+A(2,1)+A(3,1)
               G(1)=HWSGAM(AA)/(HWSGAM(A(2,1))*HWSGAM(ONE+A(3,1)))
               G(2)=0.
@@ -535,8 +612,14 @@
 C
         IF (NSET.LT.3.OR.NSET.EQ.5) THEN
           DO 50 I=1,5
+#if !defined(CERNLIB_GFORTRAN)
    50     F(I)=A(1,I)*X**A(2,I)*XMWN**A(3,I)*(ONE+X*
      &        (A(4,I)+X*(A(5,I)  +  X*A(6,I))))
+#else
+             F(I)=A(1,I)*X**A(2,I)*XMWN**A(3,I)*(ONE+X*
+     &        (A(4,I)+X*(A(5,I)  +  X*A(6,I))))
+   50     continue
+#endif
           F(1)=F(1)*G(1)
           F(2)=F(2)*G(2)
           UPV=F(1)-F(2)
@@ -570,7 +653,12 @@
           XQSUM=0.
           DO 110 IT=1,6
           DO 110 IX=1,6
+#if !defined(CERNLIB_GFORTRAN)
   110     XQSUM=XQSUM+CEHLQ(IX,IT,NX,IFL,IP)*TX(IX)*TT(IT)
+#else
+            XQSUM=XQSUM+CEHLQ(IX,IT,NX,IFL,IP)*TX(IX)*TT(IT)
+  110     continue
+#endif
   120     XQ(IFL)=XQSUM*XMWN**NEHLQ(IFL,IP)
           UPV=XQ(1)
           DNV=XQ(2)
@@ -593,7 +681,12 @@
             XQSUM=0.
             DO 130 IT=1,6
             DO 130 IX=1,6
+#if !defined(CERNLIB_GFORTRAN)
   130       XQSUM=XQSUM+CEHLQ(IX,IT,NX,7,IP)*TX(IX)*TB(IT)
+#else
+              XQSUM=XQSUM+CEHLQ(IX,IT,NX,7,IP)*TX(IX)*TB(IT)
+  130       continue
+#endif
             BTM=XQSUM*XMWN**NEHLQ(7,IP)
           ENDIF
 C...SPECIAL EXPANSION FOR TOP (THRESHOLD EFFECTS)
@@ -614,7 +707,12 @@
             XQSUM=0.
             DO 150 IT=1,6
             DO 150 IX=1,6
+#if !defined(CERNLIB_GFORTRAN)
   150       XQSUM=XQSUM+CEHLQ(IX,IT,NX,8,IP)*TX(IX)*TB(IT)
+#else
+              XQSUM=XQSUM+CEHLQ(IX,IT,NX,8,IP)*TX(IX)*TB(IT)
+  150       continue
+#endif
             TOP=XQSUM*XMWN**NEHLQ(8,IP)
           ENDIF
         ENDIF
@@ -655,7 +753,12 @@
          DIST(8)=USEA+UPV
       ELSE
          PRINT *,' CALLED HWSFUN FOR IDHAD =',IDHAD
+#if !defined(CERNLIB_GFORTRAN)
          CALL HWWARN('HWSFUN',400,*999)
+#else
+         call hwwarn('HWSFUN',400,iret)
+        if (iret .eq. 1) go to 999
+#endif
       ENDIF
   900 DIST(3)=STR
       DIST(4)=CHM
